#!/usr/bin/env python

import string
import fnmatch
import dircache
import os
import sys
import re
import tempfile

def makeInlineappletcode(matchedMathObj):
	matchedMathStr=matchedMathObj.group(0)
	tfile=open(tfn+'.tex','w')
	tfile.write('\input amstex \n')
	tfile.write('\\nopagenumbers \n')
	tfile.write(matchedMathStr)
	tfile.write('\n')
	tfile.write('\\bye')
	tfile.close()
	comstr='/usr/bin/tex  --interaction nonstopmode '+tfn+r" >/dev/null"
	os.system(comstr)
	comstr='/usr/bin/dvips -E -f -q '+tfn+'.dvi >'+tfn+'.ps'
	os.system(comstr)
	tfile=open(tfn+'.ps','r')
	bboxline=tfile.readlines()[3]
	bboxwords=string.split(bboxline)
	width=3*(string.atoi(bboxwords[3])-string.atoi(bboxwords[1]))
	height=5*(string.atoi(bboxwords[4])-string.atoi(bboxwords[2]))
	appletstr='<applet code="webeq.Main" archive="webeq.zip" codebase="../../../classes" width="'+str(width)+'" height="'+str(height)+'"><param name="size" value="18" /> <param name="color" value="#ffffff" /> <param name="eq" value="'+matchedMathStr[1:-1]+'" /></applet>'
	return appletstr

def makeDisplayappletcode(matchedMathObj):
	matchedMathStr=matchedMathObj.group(0)
	tfile=open(tfn+'.tex','w')
	tfile.write('\def\[{$$} \n')
	tfile.write('\def\]{$$} \n')
	tfile.write('\def\\array{\matrix} \n')
	tfile.write('\def\\\{\cr} \n')
	tfile.write('\\nopagenumbers \n')
	tfile.write(matchedMathStr)
	tfile.write('\n')
	tfile.write('\\bye')
	tfile.close()
	comstr='/usr/bin/tex  --interaction nonstopmode '+tfn+r" >/dev/null"
	os.system(comstr)
	comstr='/usr/bin/dvips -E -f -q '+tfn+'.dvi >'+tfn+'.ps'
	os.system(comstr)
	tfile=open(tfn+'.ps','r')
	bboxline=tfile.readlines()[3]
	bboxwords=string.split(bboxline)
	width=3*(string.atoi(bboxwords[3])-string.atoi(bboxwords[1]))
	height=5*(string.atoi(bboxwords[4])-string.atoi(bboxwords[2]))
	appletstr='<applet code="webeq.Main" archive="webeq.zip" codebase="../../../classes" width="'+str(width)+'" height="'+str(height)+'"><param name="size" value="18" /> <param name="color" value="#ffffff" /> <param name="eq" value="'+matchedMathStr[2:-2]+'" /></applet>'
	return appletstr



mhtmlfilename=sys.argv[1]

mhtmlfile=open(mhtmlfilename,'r')

text=mhtmlfile.read()

mhtmlfile.close()

tempfile.tempdir=os.getcwd()

tfn=tempfile.mktemp()


inlinemathMatch=re.compile("\$([^$]*)\$")

result1=re.sub(inlinemathMatch,makeInlineappletcode,text)

displaymathMatch=re.compile(r"\\\["+'([^'+r"\]"+']*)'+r"\]")

result=re.sub(displaymathMatch,makeDisplayappletcode,result1)

print result
	
